import path from 'path'
import Webpack from 'webpack'
import nodeExternals from 'webpack-node-externals'
import NodemonPlugin from 'nodemon-webpack-plugin'

export default ({ entry }) => ({
  entry: ['babel-polyfill', entry],
  target: 'node',
  output: {
    path: path.resolve('./build'),
    filename: 'index.js',
    libraryTarget: 'commonjs2'
  },
  externals: [
    nodeExternals({
      whitelist: [
        'babel-polyfill'
      ]
    })
  ],
  resolve: {
    extensions: ['.web.js', '.js', '.json', '.web.jsx', '.jsx', '.json']
  },
  module: {
    rules: [
      {
        test: /\.(js|jsx)$/,
        loader: 'babel-loader',
        options: {
          cacheDirectory: true
        },
        exclude: [/node_modules/]
      }
    ]
  },
  plugins: [
    new NodemonPlugin(),
    new Webpack.NoEmitOnErrorsPlugin(),
    new Webpack.DefinePlugin({
      'process.env.WEBPACK': true
    }),
    new Webpack.LoaderOptionsPlugin({
      minimize: false,
      debug: false
    })
  ]
})
